"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Interceptor = void 0;
exports.compose = compose;
var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var Interceptor = function () {
  function Interceptor(finalIterceptor) {
    _classCallCheck(this, Interceptor);
    _defineProperty(this, "onSuccess", void 0);
    _defineProperty(this, "onError", void 0);
    _defineProperty(this, "finalIterceptor", void 0);
    this.finalIterceptor = finalIterceptor;
    this.onSuccess = [];
    this.onError = [];
  }
  _createClass(Interceptor, [{
    key: "use",
    value: function use(_ref) {
      var onSuccess = _ref.onSuccess,
        onError = _ref.onError;
      if (!!onSuccess && typeof onSuccess !== 'function') {
        throw new Error('success interceptor shoud be a functoin');
      }
      if (!!onError && typeof onError !== 'function') {
        throw new Error('error interceptor shoud be a functoin');
      }
      this.onSuccess = [].concat(_toConsumableArray(this.onSuccess), [onSuccess]).filter(Boolean);
      this.onError = [].concat(_toConsumableArray(this.onError), [onError]).filter(Boolean);
      return this.removeInterceptor(onSuccess, onError);
    }
  }, {
    key: "run",
    value: function run(data) {
      var _this = this;
      return Promise.resolve(compose.apply(void 0, _toConsumableArray(this.onSuccess))(_objectSpread({}, data)))
      .then(function (data) {
        return _this.finalIterceptor ? _this.finalIterceptor(data) : data;
      });
    }
  }, {
    key: "err",
    value: function err(data) {
      var _this2 = this;
      return Promise.resolve(compose.apply(void 0, _toConsumableArray(this.onError))(_objectSpread({}, data)))
      .then(function (data) {
        return _this2.finalIterceptor ? _this2.finalIterceptor(data) : data;
      });
    }
  }, {
    key: "removeInterceptor",
    value: function removeInterceptor(onSuccess, onError) {
      var _this3 = this;
      return function () {
        _this3.onSuccess = _this3.onSuccess.filter(function (item) {
          return item !== onSuccess;
        });
        _this3.onError = _this3.onError.filter(function (item) {
          return item !== onError;
        });
      };
    }
  }]);
  return Interceptor;
}();
exports.Interceptor = Interceptor;
function compose() {
  for (var _len = arguments.length, functions = new Array(_len), _key = 0; _key < _len; _key++) {
    functions[_key] = arguments[_key];
  }
  if (!Array.isArray(functions) || (0, _isEmpty.default)(functions)) {
    return function (arg) {
      return arg;
    };
  }
  if (functions.length === 1) {
    return functions[0];
  }
  return functions.reduce(function (a, b) {
    return function () {
      return a(b.apply(void 0, arguments));
    };
  });
}
//# sourceMappingURL=Interceptor.js.map