import { Interceptor } from './Interceptor';
import { Params, CancelablePromise, ParamsType, BaseConfigsType } from './types';
type ResponceInterceptor = (data: {
    response: Response;
}) => Response | any;
type RequestInterceptor = (data: Params) => Params;
export declare class API {
    configs: BaseConfigsType;
    interceptors: {
        response: Interceptor<ResponceInterceptor>;
        request: Interceptor<RequestInterceptor>;
    };
    constructor(configs?: Omit<Partial<BaseConfigsType>, 'interceptors'>);
    request(requestParams: Params): CancelablePromise;
    get(endpoint: string, params?: ParamsType): CancelablePromise;
    post(endpoint: string, body?: any, params?: ParamsType): CancelablePromise;
    put(endpoint: string, body?: any, params?: ParamsType): CancelablePromise;
    patch(endpoint: string, body?: any, params?: ParamsType): CancelablePromise;
    options(endpoint: string, params?: ParamsType): CancelablePromise;
    delete(endpoint: string, params?: ParamsType): CancelablePromise;
}
export {};
