"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.API = void 0;
var _get = _interopRequireDefault(require("lodash/get"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _buildUrl = require("./utils/buildUrl");
var _mergeConfigs = require("./utils/mergeConfigs");
var _apiHelpers = require("./utils/apiHelpers");
var _defaults = _interopRequireDefault(require("./defaults"));
var _excluded = ["baseURL", "endpoint", "params", "method", "headers", "paramsSerializer", "isMultipartFormData", "body"],
  _excluded2 = ["url"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
var API = function () {
  function API(configs) {
    _classCallCheck(this, API);
    _defineProperty(this, "configs", void 0);
    _defineProperty(this, "interceptors", void 0);
    var options = (0, _mergeConfigs.mergeConfigs)((0, _omit.default)(configs, 'interceptors'), _defaults.default);
    this.configs = (0, _omit.default)(options, 'interceptors');
    this.interceptors = options.interceptors;
  }
  _createClass(API, [{
    key: "request",
    value: function request(requestParams) {
      var _this = this;
      var _requestParams$baseUR = requestParams.baseURL,
        baseURL = _requestParams$baseUR === void 0 ? this.configs.baseURL : _requestParams$baseUR,
        _requestParams$endpoi = requestParams.endpoint,
        endpoint = _requestParams$endpoi === void 0 ? '' : _requestParams$endpoi,
        params = requestParams.params,
        _requestParams$method = requestParams.method,
        method = _requestParams$method === void 0 ? 'GET' : _requestParams$method,
        _requestParams$header = requestParams.headers,
        headers = _requestParams$header === void 0 ? {} : _requestParams$header,
        _requestParams$params = requestParams.paramsSerializer,
        paramsSerializer = _requestParams$params === void 0 ? this.configs.paramsSerializer : _requestParams$params,
        _requestParams$isMult = requestParams.isMultipartFormData,
        isMultipartFormData = _requestParams$isMult === void 0 ? this.configs.isMultipartFormData : _requestParams$isMult,
        body = requestParams.body,
        restOptions = _objectWithoutProperties(requestParams, _excluded);
      var url = (0, _buildUrl.buildUrl)(baseURL, endpoint, params, paramsSerializer);
      var _headers = new Headers(Object.assign({}, this.configs.headers, headers));
      var _isMultipartFormData = typeof isMultipartFormData === 'function' ? this.configs.isMultipartFormData(body || {}) : isMultipartFormData === true;
      if (_isMultipartFormData) {
        _headers.delete('Content-Type');
      }

      var _body = this.configs.prepareBody(body || {}, _isMultipartFormData, method, _headers.get('Content-Type'));
      var options = _objectSpread(_objectSpread({}, restOptions), {}, {
        method: method,
        headers: _headers,
        body: _body
      });
      var controller = new AbortController();
      var wrappedPromise = this.interceptors.request.run(_objectSpread(_objectSpread({}, options), {}, {
        url: url
      }))
      .then(function (_ref) {
        var url = _ref.url,
          opts = _objectWithoutProperties(_ref, _excluded2);
        var request = new Request(url, _objectSpread(_objectSpread({}, opts), {}, {
          signal: (0, _get.default)(opts, 'signal') || controller.signal
        }));
        return fetch(request);
      })
      .then(function (response) {
        return (0, _apiHelpers.handleResponseCallback)(response);
      })
      .then(function (data) {
        if ((0, _get.default)(data, 'response.ok')) {
          return data;
        }
        return Promise.reject(data);
      })
      .then(function (data) {
        return _this.interceptors.response.run(data);
      })
      .catch(function (err) {
        if ((0, _get.default)(err, 'code') === 20) {
          var errorr = err;
          return Promise.reject({
            errors: {
              code: errorr.code,
              message: errorr.message,
              name: errorr.name
            }
          });
        }
        return _this.interceptors.response.err((0, _get.default)(err, 'data') || err).then(function (err) {
          throw err;
        });
      });
      wrappedPromise.cancel = function () {
        controller.abort();
      };
      return wrappedPromise;
    }
  }, {
    key: "get",
    value: function get(endpoint, params) {
      return this.request((0, _apiHelpers.makeParams)(endpoint, 'GET', params));
    }
  }, {
    key: "post",
    value: function post(endpoint, body, params) {
      return this.request((0, _apiHelpers.makeBodyParams)(endpoint, 'POST', body, params));
    }
  }, {
    key: "put",
    value: function put(endpoint, body, params) {
      return this.request((0, _apiHelpers.makeBodyParams)(endpoint, 'PUT', body, params));
    }
  }, {
    key: "patch",
    value: function patch(endpoint, body, params) {
      return this.request((0, _apiHelpers.makeBodyParams)(endpoint, 'PATCH', body, params));
    }
  }, {
    key: "options",
    value: function options(endpoint, params) {
      return this.request((0, _apiHelpers.makeParams)(endpoint, 'OPTIONS', params));
    }
  }, {
    key: "delete",
    value: function _delete(endpoint, params) {
      return this.request((0, _apiHelpers.makeParams)(endpoint, 'DELETE', params));
    }
  }]);
  return API;
}();
exports.API = API;
//# sourceMappingURL=api.js.map