"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkUrl = checkUrl;
exports.finalResponseIterceptor = finalResponseIterceptor;
exports.handleResponseCallback = handleResponseCallback;
exports.makeBodyParams = makeBodyParams;
exports.makeParams = makeParams;
var _has = _interopRequireDefault(require("lodash/has"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function checkUrl(url) {
  if (!url) {
    throw new Error('endpoint is required but got: empty string');
  }
}
function makeParams(url, method, params) {
  checkUrl(url);
  return _objectSpread(_objectSpread({}, params || {}), {}, {
    endpoint: url,
    method: method
  });
}
function makeBodyParams(url, method, body, params) {
  checkUrl(url);
  return _objectSpread(_objectSpread({}, params || {}), {}, {
    endpoint: url,
    body: body,
    method: method
  });
}
function handleResponseCallback(response) {
  var _response$headers;
  if (response !== null && response !== void 0 && (_response$headers = response.headers) !== null && _response$headers !== void 0 && _response$headers.get && (response.headers.get('Content-Type') || '').includes('application/json')) {
    return response.json().then(function (data) {
      return {
        data: data,
        response: response
      };
    });
  }
  return Promise.resolve({
    response: response
  });
}
function finalResponseIterceptor(response) {
  return (0, _has.default)(response, 'data') ? response.data : response;
}
//# sourceMappingURL=apiHelpers.js.map