"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildUrl = buildUrl;
var _pathToRegexp = require("path-to-regexp");
var _clearParams = require("./clearParams");
var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));
var _paramsSerializer = require("./paramsSerializer");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function buildUrl(baseURL, endpoint, params) {
  var paramsSerializer = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _paramsSerializer.paramsSerializer;
  if (typeof endpoint !== 'string') {
    throw new Error('enpoint param should be a string');
  }
  if (!(0, _isEmpty.default)(params) && _typeof(params) !== 'object') {
    throw new Error('params should be an object');
  }
  var _endpoint = endpoint;
  var _params = params;
  if (/\/:/.test(endpoint) && params && !(0, _isEmpty.default)(params)) {
    _endpoint = (0, _pathToRegexp.compile)(endpoint)(params);
    _params = (0, _clearParams.clearParams)(endpoint, params);
  }
  var queryParams = (0, _isEmpty.default)(_params) || !_params ? '' : "?".concat(paramsSerializer(_params));
  return "".concat(baseURL).concat(_endpoint).concat(queryParams).replace(/(https?:\/\/)|(\/)+/g, '$1$2');
}
//# sourceMappingURL=buildUrl.js.map