"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearParams = clearParams;
var _pathToRegexp = require("path-to-regexp");
var _omit = _interopRequireDefault(require("lodash/omit"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function clearParams(endpoint, params) {
  if (!endpoint) {
    return params;
  }
  var keys = (0, _pathToRegexp.parse)(endpoint);
  var keysToOmit = keys.map(function (token) {
    return typeof token === 'string' ? '' : token.name;
  }).filter(Boolean);
  return (0, _omit.default)(params, keysToOmit);
}
//# sourceMappingURL=clearParams.js.map