"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deepValues = deepValues;
exports.hasFile = hasFile;
var _isPlainObject = _interopRequireDefault(require("lodash/isPlainObject"));
var _flatMapDeep = _interopRequireDefault(require("lodash/flatMapDeep"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function hasFile(obj) {
  if (obj instanceof FormData) {
    return true;
  }
  return deepValues(obj).some(function (v) {
    return v instanceof File;
  });
}

function deepValues(obj) {
  if ((0, _isPlainObject.default)(obj) || Array.isArray(obj)) {
    return (0, _flatMapDeep.default)(obj, deepValues);
  }
  return [obj];
}
//# sourceMappingURL=hasFile.js.map