"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prepareBody = prepareBody;
var _converToFormData = require("./converToFormData");
function prepareBody(body, isMultipartFormData, method, contentType) {
  if (method === 'GET') {
    return undefined;
  }
  if (body instanceof FormData) {
    return body;
  }
  if (contentType && !['application/json', 'form-data'].find(function (item) {
    return item.includes(contentType);
  })) {
    return body;
  }
  if (isMultipartFormData) {
    return (0, _converToFormData.converToFormData)(new FormData(), body);
  }
  return JSON.stringify(body);
}
//# sourceMappingURL=prepareBody.js.map